%define section free

Summary:        DOM4J
Name:           dom4j
Version:        1.5
Release:        1jpp_1rh
Epoch:          0
License:        BSD-style
URL:            http://www.dom4j.org/
Group:          Text Processing/Markup/XML
#Vendor:         JPackage Project
#Distribution:   JPackage
Source0:        dom4j-1.5.tar.gz
Source1:        dom4j_rundemo.sh
Patch0:         dom4j-xpp2.1.10.patch
BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:  ant >= 0:1.6
BuildRequires:  junit
BuildRequires:  jtidy
BuildRequires:  junitperf
BuildRequires:  isorelax
BuildRequires:  jaxen-bootstrap
BuildRequires:  msv-strict
BuildRequires:  relaxngDatatype
BuildRequires:  stax-bea
BuildRequires:  ws-jaxme
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-apis
BuildRequires:  xpp2 >= 0:2.1.10-1jpp
BuildRequires:  xsdlib
Requires:  xpp2 >= 0:2.1.10-1jpp
Requires:  xerces-j2
Requires:  msv-strict
Requires:  xsdlib
Requires:  relaxngDatatype
Requires:  isorelax
Requires:  jaxen
Requires:  stax-bea
Requires:  ws-jaxme
Requires:  xalan-j2
Requires:  xml-commons-apis
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
dom4j is an Open Source XML framework for Java. dom4j allows you to read,
write, navigate, create and modify XML documents. dom4j integrates with 
DOM and SAX and is seamlessly integrated with full XPath support. 

%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation
Requires:       dom4j >= 0:1.5-1jpp

%description demo
Samples for %{name}.

%package manual
Summary:        Manual for %{name}
Group:          Development/Documentation

%description manual
Documentation for %{name}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.


%prep
%setup -q -n %{name}-%{version}
# replace run.sh
cp %{SOURCE1} run.sh
# remove binary libs
find . -name "*.jar" -exec rm -f {} \;
# during development, save ProxyXmlStartTag.java
# cp src/java/org/dom4j/xpp/ProxyXmlStartTag.java src/java/org/dom4j/xpp/ProxyXmlStartTag.java.sav
# fix for deleted jars
mv build.xml build.xml.orig
sed -e '/unjar/d' -e 's|,cookbook/\*\*,|,|' build.xml.orig > build.xml
# TestBeans will fail in headless env
rm src/test/org/dom4j/bean/TestBeans.java

%patch0 -b .sav

%build
export CLASSPATH=$(build-classpath \
isorelax \
jaxen \
jaxme/jaxmeapi \
jaxme/jaxme2 \
jaxme/jaxmejs \
jaxme/jaxmexs \
jtidy \
junit \
junitperf \
msv-strict \
relaxngDatatype \
stax-bea-api \
stax-bea-ri \
xalan-j2 \
xerces-j2 \
xml-commons-apis \
xpp2 \
xsdlib \
)
CLASSPATH=$CLASSPATH:build/classes:.
ant -Dbuild.sysclasspath=only all samples test

%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/%{name}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/doc/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}

# manual
mkdir -p $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
rm -rf docs/apidocs
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/classes/org/dom4j
cp -pr xml $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/src
cp -pr src/samples $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/src
cp -pr build/classes/org/dom4j/samples $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/classes/org/dom4j
cp -p run.sh $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%changelog
* Wed Apr 27 2005 Fernando Nasser <fnasser@redhat.com> 0:1.5-1jpp_1rh
- First Red Hat build

* Thu Sep 09 2004 Ralph Apel <r.apel@r-apel.de> - 0:1.5-1jpp
- Upgrade to 1.5
- Drop saxpath requirement as this is now included in jaxen

* Fri Aug 20 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-3jpp
- Upgrade to Ant 1.6.X
- Build with ant-1.6.2

* Tue Jul 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.4-2jpp
- Replace non-free msv with free relaxngDatatype xsdlib isorelax msv-strict
- Relax some versioned dependencies

* Mon Jan 19 2004 Ralph Apel <r.apel@r-apel.de> - 0:1.4-1jpp
- First JPackage release
